require 'Korundum'

class GoogleTranslator < KDE::HTMLPart
    k_dcop 'void translate(QString, QString, QCString, QCString)'
    slots 'progress(int)'
    def initialize
        super
        connect(browserExtension(), SIGNAL('loadingProgress(int)'),
                self, SLOT('progress(int)'))
    end
    def translate(text, direction, appId, interface)
        @direction = direction
        @client = KDE::DCOPRef.new(appId, interface)
        @url = KDE::URL.new("http://translate.google.com/translate_t?text=%s&langpair=%s" %
            [text, direction])
        openURL(@url)
    end
    def progress(percent)
        if percent == 100 && !@url.nil?
            src = htmlDocument.toString.string
            if src =~ %r{<TEXTAREA.*>([^>]*)</TEXTAREA>.*<TEXTAREA.*>([^>]*)</TEXTAREA>}
                @client.translation($1)
                @url = nil
            end
        end
    end
end

aboutdata = KDE::AboutData.new("googletranslator", "KDE",
                 "0.1", "A Google based translation service",
                 KDE::AboutData::License_GPL, "(C) 2006, Richard Dale")

KDE::CmdLineArgs.init(ARGV, aboutdata)
if !KDE::UniqueApplication.start
    puts "googletranslator is already running!"
    exit(0)
end

app = KDE::UniqueApplication.new
service = GoogleTranslator.new
app.exec
